from crowdkit.aggregation.base_embedding_aggregator import BaseEmbeddingAggregator
from pandas.core.frame import DataFrame

class RASA(BaseEmbeddingAggregator):
    """Reliability Aware Sequence Aggregation
    Jiyi Li. 2019.
    A Dataset of Crowdsourced Word Sequences: Collections and Answer Aggregation for Ground Truth Creation.
    Proceedings of the First Workshop on Aggregating and Analysing Crowdsourced Annotations for NLP,
    pages 24–28 Hong Kong, China, November 3, 2019.
    http://doi.org/10.18653/v1/D19-5904
    """

    def __init__(self, n_iter: int = 100, alpha: float = ...) -> None:
        """Method generated by attrs for class RASA.
        """
        ...

    def fit(self, data: DataFrame, true_embeddings: DataFrame = None) -> 'RASA':
        """Args:
            data (DataFrame): Performers' outputs with their embeddings
                A pandas.DataFrame containing `task`, `performer`, `output` and `embedding` columns.
            true_embeddings (DataFrame): Tasks' embeddings
                A pandas.DataFrame indexed by `task` with a single column `embedding`.
        Returns:
            RASA: self
        """
        ...

    def fit_predict(self, data: DataFrame, true_embeddings: DataFrame = None) -> DataFrame:
        """Args:
            data (DataFrame): Performers' outputs with their embeddings
                A pandas.DataFrame containing `task`, `performer`, `output` and `embedding` columns.
            true_embeddings (DataFrame): Tasks' embeddings
                A pandas.DataFrame indexed by `task` with a single column `embedding`.
        Returns:
            DataFrame: Tasks' most likely true labels
                A pandas.Series indexed by `task` such that `labels.loc[task]`
                is the tasks's most likely true label.
        """
        ...

    def fit_predict_scores(self, data: DataFrame, true_embeddings: DataFrame = None) -> DataFrame:
        """Args:
            data (DataFrame): Performers' outputs with their embeddings
                A pandas.DataFrame containing `task`, `performer`, `output` and `embedding` columns.
            true_embeddings (DataFrame): Tasks' embeddings
                A pandas.DataFrame indexed by `task` with a single column `embedding`.
        Returns:
            DataFrame: Tasks' label scores
                A pandas.DataFrame indexed by `task` such that `result.loc[task, label]`
                is the score of `label` for `task`.
        """
        ...

    n_iter: int
    alpha: float
